import java.io.*;
import java.net.Socket;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Random;


public class connection extends Thread {
	static int anzahlVerbindungen;
	int threadID;
	boolean x = true;
	private Socket connectionSocket;
	private String[] empfangen;
	public String benutzer;
	room room;
	public boolean roomCreated = false;
	//ArrayList<connection> roomConnectionList = new ArrayList<connection>();
	public boolean currentDrawer = false;
	DataOutputStream outToClient;
	String i = "#";
	String o = "~";
	public connection(Socket s) {
		connectionSocket = s;
		benutzer = "";
		threadID = anzahlVerbindungen;
		anzahlVerbindungen++;
	}
	
	public void run(){ // run-Methode wird in 2tem Thread ausgefhrt, wenn object.start aufgerufen wird
		
		String msgEmpfangen = "";
		printScreen("Thread " + threadID + " gestartet");
		while (x) {
			try {
				BufferedReader inFromClient = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream()));
				outToClient = new DataOutputStream(connectionSocket.getOutputStream());
				
				msgEmpfangen = inFromClient.readLine();
				printScreen(msgEmpfangen, "-->");
				empfangen = msgEmpfangen.split("#");
				
				switch (empfangen[0]) {
					case "createRoom": printScreen("createRoom wird ausgefhrt"); createRoom(); break;
					case "joinRoom": printScreen("joinRoom wird ausgefhrt"); joinRoom(); break;
					case "drawLineIn": room.drawLineIn(empfangen[1]); break;
					case "clearDraw": room.sendToRoom("clearDraw", new String [] {}, "Draw wurde gecleart"); break;
					case "startGame": printScreen("startGame wird ausgefhrt"); room.startGame(empfangen[1], benutzer); break;
					case "message": printScreen("messageIn wird ausgefhrt"); messageIn(); break;
					//case "msgEmpfangen": printScreen("msgEmpfangen wird ausgefhrt"); msgEmpfangen(); break;
					
					
				}
				
			} catch (NullPointerException e) {
				printScreen("Empfangen msg: " + msgEmpfangen);
				e.printStackTrace();
				x = false;
			} catch (Exception e) {
				//e.printStackTrace();
				x = false;
			}
						
		}
		x = true;
		try {
			connectionSocket.close();
		} catch (IOException e) {
			printScreen(e.toString());
		}
		mainClass.conList.remove(this);
		try {
			room.playerLeft(this);
		} catch (Exception e) {}
		room = null;
		printScreen("Getrennt von " + connectionSocket.getRemoteSocketAddress());
		anzahlVerbindungen--;
		printScreen("Anzahl aktueller Verbindungen: " + Integer.toString(mainClass.conList.size()));
		this.stop();
	}
	
	private void messageIn() {
		// [0] benutzer, [1] text
		String data[] = empfangen[1].split("~");
		if (data[1].equalsIgnoreCase(room.currentWord)) { //wenn wort richt erraten
			if (this != room.currentDrawer) { //wenn nicht currentDrawer
				if (!room.players.getValue2(this)) { //wenn noch nicht erraten
					room.sendToRoom("messageOut", new String[] {"DrawX", data[0] + " hat das Wort erraten"}, data[0] + " hat das Wort erraten");
				}
				room.players.addToValue(this, room.roundTimer.getCurrentSeconds()); //setze Punkte in scoreboard
				room.players.addToValue(room.currentDrawer, room.roundTimer.getTotalSeconds() / room.players.size() / 2); //setze Punkte von currentDrawer
				room.players.setValue2(this, true); //setze auf scoreboard erraten auf true
				room.roundTimer.guessRight(); //verkrze zeit
				if (room.players.allGuessed()) { //wenn alle bereits erraten
					room.roundTimer.setTo0();
				}
				room.reloadPlayers();				
			}
		} else {
			room.sendToRoom("messageOut", new String[] {data[0], data[1]}, "Message " + data[1] + " an Spieler gesendet");
		}
		
	}
	
	private void createRoom() {
		String data[] = empfangen[1].split("~");
		benutzer = data[2];
		String temp = randomString();
		room = new room(temp);
		room.players.add(this);
		roomCreated = true;
		mainClass.roomList.add(room);
		printScreen(benutzer + " wurde dem Room " + room.name + " hinzugefgt");
		send("roomCreated", new String[] {room.name});
		//room.scoreboardList.add(0);
		room.reloadPlayers();
	}

	private void joinRoom() {
		String data[] = empfangen[1].split("~");
		benutzer = data[2];
		if (checkRoomExist(data[3])) {
			for (room item : mainClass.roomList) {
				if (item.name.equalsIgnoreCase(data[3])){
					room = item;
				}
			}
			printScreen("Mitspieler in Room " + benutzer + " in " + room.name);
			room.players.add(this);
			send("roomJoined", new String[] {"1", room.name}); // send true
			//room.scoreboardList.add(0);
			room.reloadPlayers();
		} else {
			printScreen("Room \"" + data[3] + "\" existiert nicht");
			send("roomJoined", new String[] {"0"}); // send false
		}
		
	}
	
	public boolean checkRoomExist(String roomname) {
		boolean ret = false;
		for (room item : mainClass.roomList) {
			if (item.name.equalsIgnoreCase(roomname)) ret = true;
		}
		return ret;
	}
	
	
	
	
	
	

	
	
	public String randomString() {
		int leftLimit = 97; // letter 'a'
	    int rightLimit = 122; // letter 'z'
	    int targetStringLength = 3;
	    Random random = new Random();
	    StringBuilder buffer = new StringBuilder(targetStringLength);
	    for (int i = 0; i < targetStringLength; i++) {
	        int randomLimitedInt = leftLimit + (int) 
	          (random.nextFloat() * (rightLimit - leftLimit + 1));
	        buffer.append((char) randomLimitedInt);
	    }
	    String generatedString = buffer.toString();
	    return generatedString;
	}

	public void send(String methode, String[] daten) {
		String data = "";
		for (String item : daten) {
			data += item + "~";
		}
		if (!data.equals("")) {
			data = data.substring(0, data.length() - 1);			
		}
		String message = methode + i + benutzer + i + data;
		try {
			outToClient.writeBytes(message + "\n");
			printScreen(message, "<--");
		} catch (Exception e) {
			e.printStackTrace();
		} 
	}
	
	public void printScreen(String... daten) {
		LocalDateTime zeit = LocalDateTime.now();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd.MM.yyyy HH:mm:ss.SS");
		String formattedDate = zeit.format(formatter);
		String message = "";
		if (daten.length == 1) {
			message = formattedDate + " | \t" + this.threadID + "|   | " + daten[0];
			System.out.println(message);
		} else if (daten.length == 2) {
			message = formattedDate + " | \t" + this.threadID + "|" + daten[1] + "| " + daten[0];
			System.out.println(message);
		}
		if (mainClass.logging) mainClass.log(message);
		//--> IN | <-- OUT
	}
}
