import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Scanner;

public class mainClass {
	static final String VERSION = "1.0"; 
	static boolean x = true;
	static ArrayList<connection> conList = new ArrayList<connection>();
	static ArrayList<room> roomList = new ArrayList<room>();
	static PrintWriter logWriter;
	static File logdatei;
	static Thread debugT = new Thread(new debug());
	public static boolean debugging = false;
	public static boolean logging = false;
	private static int port = 35799;
	
	public static void main(String[] args) throws Exception {
		
		
		connection.anzahlVerbindungen = 0;
		InetAddress addr = InetAddress.getLocalHost();
		
		String filename = "";
		boolean customLogName = false;
		// Parameter verwerten
		for (String item : args) {
			if (item.equalsIgnoreCase("--debug")) debugging = true;
			if (item.startsWith("--log")) logging = true;
			if (item.startsWith("--log=")) filename = item.substring(6);
			if (item.startsWith("--help")) {
				System.out.println("Command usage: ");
				System.out.println("java -jar DrawXServer.jar [options]");
				System.out.println("\t--help               - Show this help.");
				System.out.println("\t--debug              - Turns on livedebugging.");
				System.out.println("\t--log                - Turns on logging into the standardoutputfile \"DrawXServer_log.txt\".");
				System.out.println("\t--log=[filename.txt] - Turns on logging into the passed filename.");
				System.exit(0);
			}
		}
		
		if (logging) {
			if (filename.equals("")) logdatei = new File("DrawXServer_log.txt"); else logdatei = new File(filename);
			logWriter = new PrintWriter(new BufferedWriter(new FileWriter(logdatei, true)));
			//Log-Verzeichnis anlegen
			if (!logdatei.exists()) {
				logdatei.createNewFile();
				printScreen(logdatei + " wurde erstellt!");
			}
		}
		
		if (debugging) {
			debugT.start();
		}


		printScreen("ServerIP: " + addr.getHostAddress() + ":" + port);
		printScreen("DrawX " + VERSION + " gestartet!");
		printScreen("Logging: " + logging);
		printScreen("Debugging: " + debugging);

		
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() { //logge wenn Prgramm beendet wird
			public void run() {
				printScreen("DrawX Gestoppt!");
			}
		}));
	
		while(true) {
			ServerSocket srvSocket = new ServerSocket(port);
			Socket connectionSocket = srvSocket.accept();
			printScreen("Verbunden mit " + connectionSocket.getRemoteSocketAddress());
			
			conList.add(new connection(connectionSocket));
			conList.get(connection.anzahlVerbindungen - 1).start();
			srvSocket.close();
		}
	
	}
	
	
	
	public static void printScreen(String text) {
		LocalDateTime zeit = LocalDateTime.now();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd.MM.yyyy HH:mm:ss.SS");
		String formattedDate = zeit.format(formatter);
		String message = formattedDate + " |\tX|   | " + text;
		System.out.println(message);
		if (logging) log(message);
	}
	
	public static void log(String text) {
		try {
			logWriter.println(text);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			logWriter.flush();
		}
	}
	
}