import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Random;

public class room {
	String name;
	public scoreboard players = new scoreboard();
	int totalRoundCount;
	int roundTime;
	int currentRound = 1;
	int currentDrawerIndex = 1;
	connection currentDrawer;
	final String wordcollection[] = {"Alphabet", "Altenheim", "Amulett", "Arm", "Aufkleber", "Auspuff", "Auto", "Ball", "Bar", "Baum", "Bestellliste", "Betttuch", "Biokraftstoff", "Blatt", "Buch", "Callcenter", "Castingshow", "Chinese", "Computer", "Dach", "Disco", "Dollar", "Eimer", "Eisenbahn", "Engel", "Erdl", "Ergebnis"};
	String currentWord;
	Thread roundTimerT;
	timer roundTimer;
	String roomAdmin;
	
	public room(String roomname) {
		name = roomname;
		printScreen("Raum " + name + " wurde erstellt");
	}
	
	public void startGame(String empfangen, String roomAdmin){
		this.roomAdmin = roomAdmin;
		String data[] = empfangen.split("~");
		totalRoundCount = Integer.parseInt(data[0]);
		roundTime = Integer.parseInt(data[1]);
		printScreen("Runden gesamt: " + totalRoundCount);
		printScreen("Rundenzeit: " + roundTime);
		printScreen("Anzahl der Spieler: " + players.getKeys().size());
		startDraw(empfangen);
	}
	
	public void startDraw(String empfangen) {
		for (int i = 4; i >= 0; i--) {
			sendToRoom("time", new String[] {Integer.toString(i)}, "");
			wait(1000);
		}
		
		// currentDrawer wird festgelegt
		for (connection item : players.getKeys()) {
			item.currentDrawer = false;
		}
		if (currentDrawerIndex > players.getKeys().size()) { // Wenn currentDrawerIndex, der letzte in der RUnde gemahlt hat, start nchste Runde
			nextRound();
		}
		players.getKeys().get(currentDrawerIndex - 1).currentDrawer = true; // Setze currentDrawer auf true
		for (connection item : players.getKeys()) {
			if (item.currentDrawer) {
				currentDrawer = item; // Setze connection-Objekt von diesem Raum auf die currentDrawer-connection
			}
		}
		printScreen("Starte Draw: " + currentDrawerIndex + " Runde: " + currentRound);
		
		//in scoreboard currentdrawer schon erraten alle anderen nicht
		for (int i = 0; i < players.size(); i++) {
			players.setValue2At(i, false);
		}
		players.setValue2(currentDrawer, true);

		
		currentDrawerIndex++;
		
		printScreen(currentDrawer.benutzer + " mahlt gerade!");

		Random r = new Random(); // Whle ein zuflliges Wort aus der wordList
		currentWord = wordcollection[r.nextInt(wordcollection.length - 1)];
		
		//sendToRoom("startDraw", new String[] {currentDrawer.benutzer, Integer.toString(currentRound), Integer.toString(totalRoundCount), currentWord}, currentDrawer.benutzer + " mahlt jetzt!");
		for (connection item : players.getKeys()) {
			item.send("startDraw", new String[] {currentDrawer.benutzer, Integer.toString(currentRound), Integer.toString(totalRoundCount), currentWord}); // Anzahl der Runden
			item.printScreen(item.benutzer + " mahlt jetzt!");
		}
		
		//sendToRoom("currentWord", new String[] {currentWord}, currentWord + " an alle gesendet");
		wait(100);
		roundTimer = new timer(roundTime, players.getKeys(), this);
		roundTimerT = new Thread(roundTimer);
		roundTimerT.start();
	}

	public void nextRound() {
		if (currentRound == totalRoundCount) {
			endGame();
		}
		printScreen("Nchste Runde wird gestartet: " + (currentRound + 1));
		currentRound++;
		currentDrawerIndex = 1;
	}
	
	public void stopDraw() {
		for (connection item : players.getKeys()) {
			item.currentDrawer = false;
		}
		for (connection item : players.getKeys()) {
			item.send("roundOver", new String[] {""});
		}
		
		startDraw("XXXX");
	}
	
	public void endGame() {
		// SPIEL VORBEI
		currentRound = 1;
		sendToRoom("endGame", new String[] {}, "");
		//Punkte
		printScreen("Spiel beendet!");
		roundTimerT.stop();
	}
	
	public void sendHint() {
		int charIndex = (int) (Math.random() * (currentWord.length() - 1));
		sendToRoomExceptDrawer("hint", new String[] {Integer.toString(charIndex), Character.toString(currentWord.charAt(charIndex))}, "Hint gesendet!");
	}
	
	public void drawLineIn(String empfangen) {
		printScreen("Linie wird gezeichnet");
		drawLineOut(empfangen);
	}
	
	public void drawLineOut(String line) {
		for (connection item : players.getKeys()) {
			if (!item.benutzer.equals(currentDrawer.benutzer)) {
				item.send("drawLineOut", new String[] {line});
				item.printScreen("Linie an " + item.benutzer + " gesendet!");
			}
		}
	}
	
	public void sendToRoom(String methode, String daten[], String printMsg) {
		if (!printMsg.equals("")) printScreen(printMsg);
		for (connection item : players.getKeys()) {
			item.send(methode, daten);
		}
	}
	
	public void sendToRoomExceptDrawer(String methode, String daten[], String printMsg) {
		if (!printMsg.equals("")) printScreen(printMsg);
		for (connection item : players.getKeys()) {
			if (!item.currentDrawer) item.send(methode, daten);
		}
		
	}
	
	public ArrayList<String> getPlayersInRoom(room r) {
		ArrayList<String> playerss = new ArrayList<String>();
		for (connection item : players.getKeys()) {
			playerss.add(item.benutzer);
		}
		return playerss;
	}
	
	public void reloadPlayers() {
		String player[] = new String[getPlayersInRoom(this).size()];
		for (int i = 0; i < player.length; i++) {
			player[i] = players.getKeysAsString().get(i);
			player[i] += "*" + players.getValues().get(i);
		}
		sendToRoom("reloadPlayers", player, "Spieler werden neu geladen");
	}
	
	
	
	public void playerLeft(connection playerCon) {
		printScreen(playerCon.benutzer + " von room " + this.name + " entfernt!");
		players.getKeys().remove(playerCon);
		if (players.size() == 0) {
			mainClass.roomList.remove(this);
			roundTimerT.stop();
			printScreen("Lsche room " + this.name + " da keine Spieler drin sind!");
		}
		reloadPlayers();
	}
	
	public ArrayList<connection> getConnectionsInRoom(String r) {
		ArrayList<connection> connectionList = new ArrayList<connection>();
		for (connection item : mainClass.conList) {
			if (item.room.name.equalsIgnoreCase(r)) {
				connectionList.add(item);
			}
		}
		System.out.println("Conns in mainClass:" + mainClass.conList.size());
		return connectionList;
	}
	
	private void wait(int t) {
		try {Thread.sleep(t);} 
		catch (InterruptedException e) {e.printStackTrace();}
	}
	
	public void printScreen(String daten) {
		LocalDateTime zeit = LocalDateTime.now();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd.MM.yyyy HH:mm:ss.SS");
		String formattedDate = zeit.format(formatter);
		String message = "";
		message = formattedDate + " | \tR|" + name + "| " + daten;
		System.out.println(message);
		if (mainClass.logging) mainClass.log(message);
		//--> IN | <-- OUT
	}
	
}
